﻿package AppDevPoint.Snippets.Database.SQLite;

import android.database.AbstractWindowedCursor;
import android.database.Cursor;

// This code was generated by AppDevPoint.
// Changes to this file may cause incorrect behavior and will be lost if the code is regenerated.

public class Reader implements AppDevPoint.Types.Database.IReader {
	private Cursor cursor;
	private Boolean FirstRead = true;

	Reader(Cursor cursor) {
		this.cursor = cursor;
	}

	public final void Close() {
		cursor.close();
		cursor = null;
	}

	public final boolean Read() {
		if (FirstRead) {
			FirstRead = false;
			return cursor.moveToFirst();
		} else
			return cursor.moveToNext();
	}

	public final Object GetColumnByIndex(int ColumnIndex) {
		switch (GetType(ColumnIndex)) {
		case FIELD_TYPE_BLOB:
			return cursor.getBlob(ColumnIndex);
		case FIELD_TYPE_FLOAT:
			return cursor.getFloat(ColumnIndex);
		case FIELD_TYPE_INTEGER:
			return cursor.getInt(ColumnIndex);
		case FIELD_TYPE_STRING:
			return cursor.getString(ColumnIndex);
		default:
			return null;
		}
	}

	public final Object GetColumnByName(String ColumnName) {
		return GetColumnByIndex(cursor.getColumnIndex(ColumnName));
	}

	private final GetTypeEnum GetType(int ColumnIndex) {
		AbstractWindowedCursor AWC = (AbstractWindowedCursor) cursor;

		if (AWC.isNull(ColumnIndex))
			return GetTypeEnum.FIELD_TYPE_NULL;
		else if (AWC.isBlob(ColumnIndex))
			return GetTypeEnum.FIELD_TYPE_BLOB;
		else if (AWC.isFloat(ColumnIndex))
			return GetTypeEnum.FIELD_TYPE_FLOAT;
		else if (AWC.isLong(ColumnIndex))
			return GetTypeEnum.FIELD_TYPE_INTEGER;
		else if (AWC.isString(ColumnIndex))
			return GetTypeEnum.FIELD_TYPE_STRING;
		else
			return GetTypeEnum.FIELD_TYPE_UNKNOWN;
	}

	private enum GetTypeEnum {
		FIELD_TYPE_BLOB, FIELD_TYPE_FLOAT, FIELD_TYPE_INTEGER, FIELD_TYPE_STRING, FIELD_TYPE_NULL, FIELD_TYPE_UNKNOWN
	}
}