﻿// This code was generated by AppDevPoint.
// Changes to this file may cause incorrect behavior and will be lost if the code is regenerated.

using System;
using System.Data.SqlServerCe;
using System.Collections;
using System.Collections.Generic;
using AppDevPoint.Types.Database;

namespace AppDevPoint.Snippets.Database.SQLCompactCE
{
    public class Database : AppDevPoint.Types.Database.IDatabase
    {
        private SqlCeConnection Conn;
        private SqlCeTransaction Trans;

        public Database(String ConnectionString)
        {
            Conn = new SqlCeConnection(ConnectionString);
        }
        public Database(String DBFile, String UserLogin, String UserPassword)
        {
            Conn = new SqlCeConnection("");
        }

        public Int32 ExecuteNonQuery(String Query, IQueryParameterCollection QueryParameters)
        {
            using (SqlCeCommand Com = new SqlCeCommand(Query, Conn))
            {
                if (Trans != null) Com.Transaction = Trans;
                if (QueryParameters != null)
                {
                    foreach (SqlCeParameter P in ((QueryParameterCollection)QueryParameters).Parameters)
                        Com.Parameters.Add(P);
                }
                return Com.ExecuteNonQuery();
            }
        }
        public AppDevPoint.Types.Database.IReader ExecuteReader(String Query, IQueryParameterCollection QueryParameters)
        {
            using (SqlCeCommand Com = new SqlCeCommand(Query, Conn))
            {
                if (Trans != null) Com.Transaction = Trans;
                if (QueryParameters != null)
                {
                    foreach (SqlCeParameter P in ((QueryParameterCollection)QueryParameters).Parameters)
                        Com.Parameters.Add(P);
                }
                return new Reader(Com.ExecuteReader());
            }
        }
        public AppDevPoint.Types.Database.IRecordSet ExecuteRecordSet(String Query, IQueryParameterCollection QueryParameters)
        {
            using (SqlCeCommand Com = new SqlCeCommand(Query, Conn))
            {
                if (Trans != null) Com.Transaction = Trans;
                if (QueryParameters != null)
                {
                    foreach (SqlCeParameter P in ((QueryParameterCollection)QueryParameters).Parameters)
                        Com.Parameters.Add(P);
                }
                return new RecordSet(Com.ExecuteResultSet(ResultSetOptions.Insensitive | ResultSetOptions.Scrollable));
            }
        }

        public void TransBegin()
        {
            if (Trans == null) Trans = Conn.BeginTransaction();
        }
        public void TransCommit()
        {
            if (Trans != null) Trans.Commit();
        }
        public void TransCancel()
        {
            if (Trans != null) Trans.Rollback();
        }

        public void Open()
        {
            Conn.Open();
        }
        public void Close()
        {
            Conn.Close();
        }

        public void Disconnect()
        {
            Conn.Dispose();
            Conn = null;
        }

        public IQueryParameterCollection GenerateQueryParameterCollection()
        {
            return new QueryParameterCollection();
        }
    }
    public class QueryParameterCollection : AppDevPoint.Types.Database.IQueryParameterCollection
    {
        internal List<SqlCeParameter> Parameters = new List<SqlCeParameter>();

        internal QueryParameterCollection()
        {
        }

        public void AddParameter(String Name, Object Value)
        {
            Parameters.Add(new SqlCeParameter(Name, Value));
        }

        public void SetParameterByName(String Name, Object Value)
        {
            foreach (SqlCeParameter P in Parameters)
            {
                if (P.ParameterName == Name)
                {
                    P.Value = Value;
                    return;
                }
            }
            Parameters.Add(new SqlCeParameter(Name, Value));
        }
        public void SetParameterByIndex(Int32 Index, Object Value)
        {
            Parameters[Index].Value = Value;
        }
    }
    public class Reader : AppDevPoint.Types.Database.IReader
    {
        private SqlCeDataReader DataReader;

        internal Reader(SqlCeDataReader DataReader)
        {
            this.DataReader = DataReader;
        }

        public void Close()
        {
            DataReader.Close();
            DataReader = null;
        }

        public Boolean Read()
        {
            return DataReader.Read();
        }

        public Object GetColumnByName(String Name)
        {
            return DataReader.GetValue(DataReader.GetOrdinal(Name));
        }
        public Object GetColumnByIndex(Int32 Index)
        {
            return DataReader.GetValue(Index);
        }
    }
    public class RecordSet : AppDevPoint.Types.Database.IRecordSet
    {
        private SqlCeResultSet ResultSet;
        private Int32 TotalRecords = -1;

        internal RecordSet(SqlCeResultSet ResultSet)
        {
            this.ResultSet = ResultSet;
        }

        public Int32 RecordCount()
        {
            if (TotalRecords == -1) TotalRecords = ((IList)ResultSet.ResultSetView).Count;
            return TotalRecords;
        }
        public Boolean HasRecords()
        {
            return ResultSet.HasRows;
        }

        public Boolean ReadPosition(Int32 Position)
        {
            return ResultSet.ReadAbsolute(Position);
        }
        public Boolean Read()
        {
            return ResultSet.Read();
        }

        public void Close()
        {
            ResultSet.Close();
            ResultSet = null;
        }

        public Object GetColumnByName(String Name)
        {
            return ResultSet.GetValue(ResultSet.GetOrdinal(Name));
        }
        public Object GetColumnByIndex(Int32 Index)
        {
            return ResultSet.GetValue(Index);
        }
    }
}