﻿// This code was generated by AppDevPoint.
// Changes to this file may cause incorrect behavior and will be lost if the code is regenerated.

using System;
using Community.CsharpSqlite.SQLiteClient;
using System.Collections.Generic;
using AppDevPoint.Types.Database;

namespace AppDevPoint.Snippets.Data.SQLite
{
    public class Database : AppDevPoint.Types.Database.IDatabase
    {
        private SqliteConnection Conn;
        private SqliteTransaction Trans;

        public Database(String ConnectionString)
        {
            Conn = new SqliteConnection(ConnectionString);
        }
        public Database(String DBFile, String UserLogin, String UserPassword)
        {
            Conn = new SqliteConnection("");
        }

        public Int32 ExecuteNonQuery(String Query, IQueryParameterCollection QueryParameters)
        {
            SqliteCommand Com = new SqliteCommand(Query, Conn);
            if (Trans != null) Com.Transaction = Trans;
            if (QueryParameters != null)
            {
                foreach (SqliteParameter P in ((QueryParameterCollection)QueryParameters).Parameters)
                    Com.Parameters.Add(P);
            }
            return Com.ExecuteNonQuery();
        }
        public AppDevPoint.Types.Database.IReader ExecuteReader(String Query, IQueryParameterCollection QueryParameters)
        {
            SqliteCommand Com = new SqliteCommand(Query, Conn);
            if (Trans != null) Com.Transaction = Trans;
            if (QueryParameters != null)
            {
                foreach (SqliteParameter P in ((QueryParameterCollection)QueryParameters).Parameters)
                    Com.Parameters.Add(P);
            }
            return new Reader(Com.ExecuteReader());
        }
        public AppDevPoint.Types.Database.IRecordSet ExecuteRecordSet(String Query, IQueryParameterCollection QueryParameters)
        {
            throw new NotImplementedException();
        }

        public void TransBegin()
        {
            if (Trans == null) Trans = Conn.BeginTransaction();
        }
        public void TransCommit()
        {
            if (Trans != null) Trans.Commit();
        }
        public void TransCancel()
        {
            if (Trans != null) Trans.Rollback();
        }

        public void Open()
        {
            Conn.Open();
        }
        public void Close()
        {
            Conn.Close();
        }

        public void Disconnect()
        {
            Conn.Dispose();
            Conn = null;
        }

        public IQueryParameterCollection GenerateQueryParameterCollection()
        {
            return new QueryParameterCollection();
        }
    }
    public class QueryParameterCollection : AppDevPoint.Types.Database.IQueryParameterCollection
    {
        internal List<SqliteParameter> Parameters = new List<SqliteParameter>();

        internal QueryParameterCollection()
        {
        }

        public void AddParameter(String Name, Object Value)
        {
            Parameters.Add(new SqliteParameter(Name, Value));
        }

        public void SetParameterByName(String Name, Object Value)
        {
            foreach (SqliteParameter P in Parameters)
            {
                if (P.ParameterName == Name)
                {
                    P.Value = Value;
                    return;
                }
            }
            Parameters.Add(new SqliteParameter(Name, Value));
        }
        public void SetParameterByIndex(Int32 Index, Object Value)
        {
            Parameters[Index].Value = Value;
        }
    }
    public class Reader : AppDevPoint.Types.Database.IReader
    {
        private SqliteDataReader DataReader;

        internal Reader(SqliteDataReader DataReader)
        {
            this.DataReader = DataReader;
        }

        public void Close()
        {
            DataReader.Close();
            DataReader.Dispose();
            DataReader = null;
        }

        public bool Read()
        {
            return DataReader.Read();
        }

        public Object GetColumnByName(String Name)
        {
            return DataReader.GetValue(DataReader.GetOrdinal(Name));
        }
        public Object GetColumnByIndex(Int32 Index)
        {
            return DataReader.GetValue(Index);
        }
    }
}